package com.example.acer.buttonapp;


import android.content.Context;
import android.content.Intent;
import android.os.Environment;
import android.os.Vibrator;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import com.instacart.library.truetime.TrueTime;
import com.instacart.library.truetime.TrueTimeRx;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PipedWriter;
import java.util.Date;

import io.reactivex.schedulers.Schedulers;

public class MainActivity extends AppCompatActivity {

    private Button bt1= null;
    private  Button bt2 = null;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        bt1 = (Button)findViewById(R.id.bt1);
        final Vibrator vibe = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);

        isExternalStorageReadable();
        isExternalStorageWritable();


        new Thread(new Runnable() {
            public void run() {
                try {
                    TrueTimeRx.build()
                            .initializeRx("time.google.com")
                            .subscribeOn(Schedulers.io())
                            .subscribe(date -> {
                                Log.v("True time", "TrueTime was initialized and we have a time: " + date);
                            }, throwable -> {
                                throwable.printStackTrace();
                            });                    //Date noReallyThisIsTheTrueDateAndTime = TrueTime.now();
                    //Log.d("TAG", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));


                } catch (Exception e) {
                    e.printStackTrace();
                }

            }

        }).start();

        bt1.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Date noReallyThisIsTheTrueDateAndTime = TrueTimeRx.now();
                String time = String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime());

                try {
                    File path = Environment.getExternalStoragePublicDirectory(
                            Environment.DIRECTORY_DOWNLOADS);
                    File myFile = new File(path, "mytextfile.txt");
                    FileOutputStream fOut = new FileOutputStream(myFile,true);
                    OutputStreamWriter myOutWriter = new OutputStreamWriter(fOut);
                    myOutWriter.append(time +  "\n");
                    Log.d("File", time);
                    myOutWriter.close();
                    fOut.close();
                }
                catch (java.io.IOException e) {
                }

                Log.d("Time", time);
                vibe.vibrate(100);
            }
        });



    }

    private boolean isExternalStorageWritable(){
        if(Environment.MEDIA_MOUNTED.equals(Environment.getExternalStorageState())){
            Log.i("state","YEs, it is writable");
            return true;
        }
        else{
            return false;
        }
    }

    private boolean isExternalStorageReadable(){
        if(Environment.MEDIA_MOUNTED.equals(Environment.getExternalStorageState())||Environment.MEDIA_MOUNTED_READ_ONLY.equals(Environment.getExternalStorageState())){
            Log.i("state","YEs, it is readable");
            return true;
        }
        else{
            return false;
        }
    }

    public void writeFile(View v,String text){
        if(isExternalStorageWritable()){

            File textFile = new File(Environment.getExternalStorageDirectory().toString());
            Log.d("File", Environment.getExternalStorageDirectory().toString());

            FileOutputStream fos = null;
            try {
                fos = new FileOutputStream(textFile);
                fos.write(text.getBytes());
                fos.close();

            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
